#!/usr/bin/perl

############################################################
# E-Blah Bulliten Board Systems          Conversion System #
############################################################
# Software Version  : Converter 10.X -- Version 3          #
# Project started   : September 2005 by Justin             #
# Distrobuted by    : http://www.eblah.com                 #
# License Agreement : http://www.eblah.com/license.php     #
############################################################
# This program is free software; you can redistribute it   #
# and/or modify it under the terms of the GNU General      #
# Public License as published by the Free Software         #
# Foundation; version 2 of the License.                    #
# This program is distributed in the hope that it will be  #
# useful, but WITHOUT ANY WARRANTY; without even the       #
# implied warranty of MERCHANTABILITY or FITNESS FOR A     #
# PARTICULAR PURPOSE.  See the GNU General Public License  #
# for more details.                                        #
############################################################
#  Copyright (c) 2005/7 E-Blah                             #
############################################################
use CGI::Carp 'fatalsToBrowser';

# Global version information:
require("Settings.pl");
require("$code/QuickCore.pl");
$language = "Languages/English";
require("$code/Load.pl");
$version = "Version 3.0";

sub CoreLoad { 1; }
sub redirect { 1; }

###################################
# Main stuff to run the script.   #
###################################

UFS();

if($URL{'convert'}) { require("$root/$URL{'convert'}.cdb"); }
	else {
		header('Choose a Converter');

		print <<"EOT";
E-Blah offers various converters for various forums.  If you do not see any converters listed below,
you probably have not downloaded or uploaded a valid conversion database file (CDB file). Click on your
corresponding converter and this script will convert that forum software to the E-Blah database format.<ul>
EOT

		opendir(DIR,"$root");
		@directory = readdir(DIR);
		closedir(DIR);

		foreach $cvert (@directory) {
			if($cvert =~ /.cdb\Z/) {
				$cvert =~ s/.cdb\Z//g;
				$cvert2 = $cvert;
				$cvert2 =~ s/_/ /g;
				$cvert2 =~ s/-/./g;
				print qq~<li><a href="?convert=$cvert">$cvert2</a></li>~;
			}
		}

		print "</ul>";
	}
footer();

sub UFS {
	my($query);
	@url = split(/\,/,$ENV{'QUERY_STRING'});
	foreach (@url) {
		($action,$actiondo) = split(/=/,$_);
		$URL{$action} = $actiondo;
	}
	read(STDIN, my $temp, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/,$temp);

	foreach (@pairs) {
		($key,$content) = split(/=/,$_);
		$content =~ tr/+/ /;
		$content =~ s/%(..)/pack("c",hex($1))/ge;
		$key =~ tr/+/ /;
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		chomp($content);
		$FORM{$key} = $content;
	}
}

sub header {
	if($header) { return(); }
	print "Content-type: text/html\n\n";

	($title) = $_[0];
	print <<"EOT";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<style type="text/css">
/* Global Table Settings */
body, table, td {
	font-family: Verdana;
	font-size  : 11px;
	color      : #1D1F22;
	margin     : 0px;
	line-height: 1.5;

}

body {
	background-color: #F1F1F1;
}

.catbg {
	background-color: #E1E1E1;
	border: 1px solid #FFF;
	font-family     : Verdana, Helvetica;
	font-size       : 12px;
	color           : #000000;
	font-weight     : bold;
}

.win {
	background-color: #F2F2F2;
}

.win2 {
	background-color: #EDEDED;
}

.border {
	background-color: #969696;
}


.smalltext { /* Small font text size, can also change color, etc */
	font-weight: normal;
	font-size  : 9px;
	line-height: 1.5;
}

/* Links */
a, a:link, a:active, a:visited {
	text-decoration: none;
	color          : #36383B;
	font-family    : Verdana, Helvetica;
	font-weight    : bold;
}

a:hover {
	text-decoration: none;
	color          : #1A1016;
	font-family    : Verdana, Helvetica;
	font-weight    : bold;
}

/* Forms */
.upload, input, textarea, select { /* .checkboxinput also allowed */
	color           : #000;
	background-color: #EEE;
	font-family     : Verdana, Helvetica, Times;
	font-size       : 10px;
	border          : 1px #8A8D96 solid;

	border-top-width   : 1px;
	border-right-width : 1px;
	border-bottom-width: 1px;
	border-left-width  : 1px;
}

input {
	padding: 3px;
}

textarea {
	padding    : 3px;
	line-height: 130%;
}

input { text-indent : 2px; margin: 0px; }

input.button {
	border : 1px solid #000;
	padding: 6px;
}

form, input {
	margin-top: 0px;
	padding: 6px;
}

form {
	margin-bottom: 0px;
}

/* New Stuff */
.title {
	padding         : 5px;
	background-color: #E1E5EB;
	font-family     : Verdana, Helvetica;
	font-size       : 20px;
}
.sub-title {
	padding         : 5px;
	background-color: #E1E1E1;
	font-family     : Verdana, Helvetica;
	font-size       : 10px;
	border-bottom   : 1px solid #B8B8B8;
	border-top      : 1px solid #B8B8B8;
}

.mainblock {
	position: relative;
	left    : 10%;
	width   : 80%;
}

.header {
	padding     : 5px;
	font-variant: small-caps;
	font-weight : bold;
}

.blockquote {
	margin      : 20px;
	margin-left : 40px;
	margin-right: 40px;
	text-align  : justify;
}

#setup-options a, #setup-options a:link, #setup-options a:active, #setup-options a:visited {

	text-decoration : none;
	text-align      : center;

	color           : #36383B;

	font-family     : Verdana, Helvetica;
	background-color: #EDEDED;
	font-weight     : normal;
	padding         : 5px;
	border          : 1px solid #B8B8B8;
	width           : 100%;

}

#setup-options a:hover {
	text-decoration : none;
	text-align      : center;
	color           : #36383B;
	font-family     : Verdana, Helvetica;
	background-color: #EDEDED;
	font-weight     : bold;
	padding         : 5px;
	border          : 1px solid #000000;
	width           : 100%;

}

.copyright {
	margin-top      : 50px;
	font-size       : 10px;
	font-family     : Verdana, Helvetica;
	text-align      : center;
	background-color: 
	font-size       : 10px;
	border-bottom   : 1px solid #B8B8B8;
	border-top      : 1px solid #B8B8B8;
	padding         : 8px;
}

.badinstall {
	background-color: #FFF5F5;
	padding         : 5px;
	border          : 1px solid #293B2A;
	color           : #FF2723;
}

.badcolor { color: #FF2723; }

.goodinstall {
	background-color: #DEE8DF;
	padding         : 5px;
	border          : 1px solid #293B2A;
	color           : #293B2A;
}

.large {
	font-size: 18px;
}
</style>
<title>$title - E-Blah Conversion</title>
</head>

<body>
<div class="title">
 <strong>$title</strong>
</div>
<div class="sub-title">
 $version Converter
</div>

<br />
<table cellpadding="5" cellspacing="1" class="border mainblock">
 <tr>
  <td class="win">
EOT
	$header = 1;
}

sub error {
	header('Error');
	print $_[0];
	footer();
}

sub footer {
	print <<"EOT";
  </td>
 </tr>
</table>
<div class="copyright">
 Copyright 2005-2007 E-Blah
</div><br />
<div style="text-align: center">
 <a href="http://validator.w3.org/check?uri=referer" target="_blank"><img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" height="31" width="88" border="0" /></a>
</div>
<br />

</body>

</html>

EOT
	exit;
}

###################################
# And now, the "Coversion 'API'"  #
###################################

sub MessageTranslate {
	my($mid,$poster,$message,$ipaddy,$emailaddress,$date) = @_;

	push(@messopen,"$mid.txt") if(!$messfile{"$mid.txt"});

	$messfile{"$mid.txt"} .= JustEdit($poster)."|".JustEdit($message)."|".JustEdit($ipaddy)."|".JustEdit($emailaddress)."|".JustEdit($date)."|0|||\n";
}

sub BoardMessageTranslate {
	my($bid,$mid,$title,$poster,$date,$replies,$lock,$lastpost,$lastposter) = @_;

	push(@boardopen,"$bid.msg") if(!$boardfile{"$bid.msg"} );

	$boardfile{"$bid.msg"} .= JustEdit($mid)."|".JustEdit($title)."|".JustEdit($poster)."|".JustEdit($date)."|".JustEdit($replies)."|0|$lock|xx|".JustEdit($lastpost)."|".JustEdit($lastposter)."\n";
}

sub BoardTranslate {
	my($bid,$desc,$name) = @_;

	push(@boardopen,'bdindex.db') if(!$boardfile{'bdindex.db'});

	$boardfile{'bdindex.db'} .= JustEdit($bid,1)."/".JustEdit($desc,1)."//".JustEdit($name,1)."/guest,validating,member/member,guest,validating/guest,validating,member////guest,member,validating/1/guest,member,validating///validating,guest,member/\n";
}

sub CatTranslate { # Seperate boards by: /
	my($catname,$catid,$boards) = @_;

	push(@boardopen,'bdscats.db') if(!$boardfile{'bdscats.db'});

	$boardfile{'bdscats.db'} .= JustEdit($catname)."|".JustEdit($catid)."|member,validating,guest|".JustEdit($boards)."\n";
}

sub MemGroupTranslate {
	my($groupname,$groupid,$members) = @_;

	$preffile{'Ranks2.txt'} .= <<"EOT";
$groupid => {
name = '$groupname'
members = ($members)
}

EOT
}

sub MembersTranslate { # Expand this?
	my($userid,$pass,$username,$email,$postcount,$aim,$icq,$yim,$msn,$regtime,$webtitle,$weburl,$extracodes) = @_;

	push(@memopen,"$userid.dat") if(!$memfile{"$userid.dat"});

	$memfile{"$userid.dat"} .= <<"EOT";
password = |$pass|
sn = |$username|
email = |$email|
posts = |$postcount|
icq = |$icq|
aim = |$aim|
msn = |$msn|
registered = |$regtime|
sitename = |$webtitle|
siteurl = |$weburl|
yim = |$yim|
dateformat = |F j, Y, g:ia|
$extracodes
EOT
}

sub MemberPMTranslate {
	($userid,$pmbox,$pmtime,$title,$user,$message,$ip) = @_;

	push(@memopen,"$userid.pm") if(!$memfile{"$userid.pm"});

	$memfile{"$userid.pm"} .= "$pmbox|$pmtime|".JustEdit($title)."|".JustEdit($user)."|".JustEdit($message)."|$ip\n";
}

sub WriteFiles {
	$members{'Administrator',''} = 1;
	$noexit = 1;

	if($URL{'do'} eq 'members' || $URL{'do'} eq '') {
		foreach(@memopen) {
			fopen(FILE,">$members/$_");
			print FILE $memfile{$_};
			fclose(FILE);
		}

		fopen(FILE,">$prefs/Ranks2.txt");
		print FILE $preffile{'Ranks2.txt'};
		fclose(FILE);

		require("$code/Admin1.pl");
		$URL{'a'} = 'convert';
		Remem();
	}

	if($URL{'do'} eq 'boards' || $URL{'do'} eq '') {
		foreach(@boardopen) {
			fopen(FILE,">$boards/$_");
			print FILE $boardfile{$_};
			fclose(FILE);
		}
	}

	if($URL{'do'} eq 'messages' || $URL{'do'} eq '') {
		if($URL{'do'} eq 'messages') {
			foreach(@boardopen) {
				fopen(FILE,">$boards/$_");
				print FILE $boardfile{$_};
				fclose(FILE);
			}
		}
		foreach(@messopen) {
			fopen(FILE,">$messages/$_");
			print FILE $messfile{$_};
			fclose(FILE);
		}
	}

	if($URL{'do'} eq 'cleanup' || $URL{'do'} eq '') {
		require("$code/Admin1.pl");
		BoardCheck();
		$URL{'p'} = 1;
		$URL{'a'} = 'remove';
		Repop();
	
		require("$code/Admin2.pl");
		PostRecount();

		unlink("$root/login.pl");

		print "Cleaned up some damage done.<br />";
	}
}

sub smail {
	my($subject,$message,$wholemessage,$tothis);
	my($to,$subject,$message,$from) = @_;
	if(!$to || !$subject || !$message) { return(-1); }
	if($to !~ /\A([0-9A-Za-z\._\-]{1,})@([0-9A-Za-z\._\-]{1,})+\.([0-9A-Za-z\._\-]{1,})+\Z/) { return(-1); }

	$message =~ s/\cM//g;
	$message =~ s/\n/<br>/gsi;
	$message =~ s/  /&nbsp; /gsi;
	$message =~ s/&lt;br&gt;/<br>/gsi;
	$message =~ s/<br>/<br>\n/gsi;
	$message =~ s/bgcolor="(.+?)"/bgcolor="#FFFFFF"/gsi;
	$emailsig = Unformat($emailsig);
	if($emailsig) { $message .= qq~<span class="smalltext"><br><br><hr size="1" color="#C0C0C0">$emailsig</span>~; }

	$wholemessage = <<"EOT";
<html>
<body bgcolor="#FFFFFF">
<font face="Verdana,Arial" color="#000000" size="2">$message</font>
</body>
</html>
EOT
	if($settings[2] ne '' && $from eq '') { $eadmin = $settings[2]; }
	if($from eq '') { $from = $regto; }
	if($eadmin eq '') { $eadmin = "noreply\@noreply.noreply"; }
	if($mailuse == 1) {
		open(MAIL,"| $smaill -t");
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-Type: text/html; charset=\"ISO-8859-1\"\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Forum-System: e-blah, $version, copyright 2001-2003\n";
		print MAIL "X-Username: $username\n";
		print MAIL "X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n";
		print MAIL "To: $to\n";
		print MAIL "From: \"$from\" <$eadmin>\n";
		print MAIL "Subject: $subject\n\n";
		print MAIL "$wholemessage";
		print MAIL "\n\n";
		close(MAIL);
	} elsif($mailuse == 2) {
		eval q{
			use Net::SMTP;
			my $smtp = Net::SMTP->new($mailhost);
			if($mailauth) { $smtp->auth($mailusername,$mailpassword); }
			$smtp->mail($eadmin);
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend("MIME-Version: 1.0\n");
			$smtp->datasend("Content-Type: text/html; charset=ISO-8859-1\n");
			$smtp->datasend("Content-Transfer-Encoding: 7bit\n");
			$smtp->datasend("X-Forum-System: e-blah, $version, copyright 2001-2003\n");
			$smtp->datasend("X-Username: $username\n");
			$smtp->datasend("X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n");
			$smtp->datasend("To: $to\n");
			$smtp->datasend("From: \"$from\" <$eadmin>\n");
			$smtp->datasend("Subject: $subject\n\n");
			$smtp->datasend("$wholemessage");
			$smtp->datasend("\n");
			$smtp->dataend();
			$smtp->quit;
		};
		if($@) { &error("[b]Net::SMTP Error[/b]\n\n$@",2); }
	}

	if($maildebug) {
		$time = time;
		fopen(OPENFILE,">$root/$time\_mailed.txt");
		print OPENFILE "To: $to\nFrom: \"$from\" <$eadmin>\nSubject: $subject\n\n$wholemessage";
		fclose(OPENFILE);
	}

	return(1); # Clean return
}
1;